ViewVC Help
View File | Revision Log | Show Annotations | Download File | Root Listing
root/radiance/ray/src/util/genBSDF.pl
(Generate patch)

Comparing ray/src/util/genBSDF.pl (file contents):
Revision 2.5 by greg, Thu Dec 9 17:00:43 2010 UTC vs.
Revision 2.33 by greg, Tue Mar 6 04:41:31 2012 UTC

# Line 6 | Line 6
6   #       G. Ward
7   #
8   use strict;
9 + use File::Temp qw/ :mktemp  /;
10   sub userror {
11 <        print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-dim xmin xmax ymin ymax zmin zmax][{+|-}mgf][{+|-}geom] [input ..]\n";
11 >        print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-t{3|4} Nlog2][-r \"ropts\"][-dim xmin xmax ymin ymax zmin zmax][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom units] [input ..]\n";
12          exit 1;
13   }
14 < my $td = `mktemp -d /tmp/genBSDF.XXXXXX`;
14 > my $td = mkdtemp("/tmp/genBSDF.XXXXXX");
15   chomp $td;
16 < my $nsamp = 1000;
16 > my @savedARGV = @ARGV;
17 > my $tensortree = 0;
18 > my $ttlog2 = 4;
19 > my $nsamp = 2000;
20 > my $rtargs = "-w -ab 5 -ad 700 -lw 3e-6";
21   my $mgfin = 0;
22   my $geout = 1;
23   my $nproc = 1;
24 + my $doforw = 0;
25 + my $doback = 1;
26 + my $pctcull = 90;
27 + my $gunit = "Meter";
28   my @dim;
29   # Get options
30   while ($#ARGV >= 0) {
31          if ("$ARGV[0]" =~ /^[-+]m/) {
32                  $mgfin = ("$ARGV[0]" =~ /^\+/);
33 +        } elsif ("$ARGV[0]" eq "-r") {
34 +                $rtargs = "$rtargs $ARGV[1]";
35 +                shift @ARGV;
36          } elsif ("$ARGV[0]" =~ /^[-+]g/) {
37                  $geout = ("$ARGV[0]" =~ /^\+/);
38 +                $gunit = $ARGV[1];
39 +                if ($gunit !~ /^(?i)(meter|foot|inch|centimeter|millimeter)$/) {
40 +                        die "Illegal geometry unit '$gunit': must be meter, foot, inch, centimeter, or millimeter\n";
41 +                }
42 +                shift @ARGV;
43 +        } elsif ("$ARGV[0]" =~ /^[-+]f/) {
44 +                $doforw = ("$ARGV[0]" =~ /^\+/);
45 +        } elsif ("$ARGV[0]" =~ /^[-+]b/) {
46 +                $doback = ("$ARGV[0]" =~ /^\+/);
47 +        } elsif ("$ARGV[0]" eq "-t") {
48 +                # Use value < 0 for rttree_reduce bypass
49 +                $pctcull = $ARGV[1];
50 +                shift @ARGV;
51 +        } elsif ("$ARGV[0]" =~ /^-t[34]$/) {
52 +                $tensortree = substr($ARGV[0], 2, 1);
53 +                $ttlog2 = $ARGV[1];
54 +                shift @ARGV;
55          } elsif ("$ARGV[0]" eq "-c") {
56                  $nsamp = $ARGV[1];
57                  shift @ARGV;
# Line 31 | Line 60 | while ($#ARGV >= 0) {
60                  shift @ARGV;
61          } elsif ("$ARGV[0]" =~ /^-d/) {
62                  userror() if ($#ARGV < 6);
63 <                @dim = "@ARGV[1..6]";
63 >                @dim = @ARGV[1..6];
64                  shift @ARGV for (1..6);
65          } elsif ("$ARGV[0]" =~ /^[-+]./) {
66                  userror();
# Line 40 | Line 69 | while ($#ARGV >= 0) {
69          }
70          shift @ARGV;
71   }
72 + # Check that we're actually being asked to do something
73 + die "Must have at least one of +forward or +backward\n" if (!$doforw && !$doback);
74 + # Name our own persist file?
75 + my $persistfile;
76 + if ( $tensortree && $nproc > 1 && "$rtargs" !~ /-PP /) {
77 +        $persistfile = "$td/pfile.txt";
78 +        $rtargs = "-PP $persistfile $rtargs";
79 + }
80   # Get scene description and dimensions
81   my $radscn = "$td/device.rad";
82   my $mgfscn = "$td/device.mgf";
# Line 49 | Line 86 | if ( $mgfin ) {
86          die "Could not load MGF input\n" if ( $? );
87          system "mgf2rad $mgfscn > $radscn";
88   } else {
89 <        system "cat @ARGV | xform -e > $radscn";
89 >        system "xform -e @ARGV > $radscn";
90          die "Could not load Radiance input\n" if ( $? );
91          system "rad2mgf $radscn > $mgfscn" if ( $geout );
92   }
93   if ($#dim != 5) {
94 <        @dim = split /\s+/, `getbbox -h $radscn`;
58 <        shift @dim;
94 >        @dim = split ' ', `getbbox -h $radscn`;
95   }
96   print STDERR "Warning: Device extends into room\n" if ($dim[5] > 1e-5);
97 < # Add receiver surface (rectangle)
98 < my $modnm="_receiver_black_";
97 > # Add receiver surfaces (rectangular)
98 > my $fmodnm="receiver_face";
99 > my $bmodnm="receiver_behind";
100   open(RADSCN, ">> $radscn");
101 < print RADSCN "void glow $modnm\n0\n0\n4 0 0 0 0\n\n";
102 < print RADSCN "$modnm polygon _receiver_\n0\n0\n12\n";
103 < print RADSCN "\t",$dim[0],"\t",$dim[2],"\t",$dim[5]+1e-5,"\n";
104 < print RADSCN "\t",$dim[0],"\t",$dim[3],"\t",$dim[5]+1e-5,"\n";
68 < print RADSCN "\t",$dim[1],"\t",$dim[3],"\t",$dim[5]+1e-5,"\n";
69 < print RADSCN "\t",$dim[1],"\t",$dim[2],"\t",$dim[5]+1e-5,"\n";
101 > print RADSCN "void glow $fmodnm\n0\n0\n4 1 1 1 0\n\n";
102 > print RADSCN "$fmodnm source f_receiver\n0\n0\n4 0 0 1 180\n";
103 > print RADSCN "void glow $bmodnm\n0\n0\n4 1 1 1 0\n\n";
104 > print RADSCN "$bmodnm source b_receiver\n0\n0\n4 0 0 -1 180\n";
105   close RADSCN;
106   # Generate octree
107   system "oconv -w $radscn > $octree";
108   die "Could not compile scene\n" if ( $? );
109 < # Set up sampling
109 > # Output XML prologue
110 > print
111 > '<?xml version="1.0" encoding="UTF-8"?>
112 > <WindowElement xmlns="http://windows.lbl.gov" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://windows.lbl.gov/BSDF-v1.4.xsd">
113 > ';
114 > print "<!-- File produced by: genBSDF @savedARGV -->\n";
115 > print
116 > '<WindowElementType>System</WindowElementType>
117 > <Optical>
118 > <Layer>
119 >        <Material>
120 >                <Name>Name</Name>
121 >                <Manufacturer>Manufacturer</Manufacturer>
122 > ';
123 > printf "\t\t<Thickness unit=\"$gunit\">%.3f</Thickness>\n", $dim[5] - $dim[4];
124 > printf "\t\t<Width unit=\"$gunit\">%.3f</Width>\n", $dim[1] - $dim[0];
125 > printf "\t\t<Height unit=\"$gunit\">%.3f</Height>\n", $dim[3] - $dim[2];
126 > print "\t\t<DeviceType>Integral</DeviceType>\n";
127 > # Output MGF description if requested
128 > if ( $geout ) {
129 >        print "\t\t<Geometry format=\"MGF\" unit=\"$gunit\">\n";
130 >        printf "xf -t %.6f %.6f 0\n", -($dim[0]+$dim[1])/2, -($dim[2]+$dim[3])/2;
131 >        open(MGFSCN, "< $mgfscn");
132 >        while (<MGFSCN>) { print $_; }
133 >        close MGFSCN;
134 >        print "xf\n";
135 >        print "\t\t</Geometry>\n";
136 > }
137 > print " </Material>\n";
138 > # Set up surface sampling
139 > my $nx = int(sqrt($nsamp*($dim[1]-$dim[0])/($dim[3]-$dim[2])) + .5);
140 > my $ny = int($nsamp/$nx + .5);
141 > $nsamp = $nx * $ny;
142 > my $ns = 2**$ttlog2;
143 > my (@pdiv, $disk2sq, $sq2disk, $tcal, $kcal);
144 > # Create data segments (all the work happens here)
145 > if ( $tensortree ) {
146 >        do_tree_bsdf();
147 > } else {
148 >        do_matrix_bsdf();
149 > }
150 > # Output XML epilogue
151 > print
152 > '</Layer>
153 > </Optical>
154 > </WindowElement>
155 > ';
156 > # Clean up temporary files and exit
157 > exec("rm -rf $td");
158 >
159 > #-------------- End of main program segment --------------#
160 >
161 > #++++++++++++++ Kill persistent rtrace +++++++++++++++++++#
162 > sub persist_end {
163 >        if ( $persistfile && open(PFI, "< $persistfile") ) {
164 >                while (<PFI>) {
165 >                        s/^[^ ]* //;
166 >                        kill('ALRM', $_);
167 >                        last;
168 >                }
169 >                close PFI;
170 >        }
171 > }
172 >
173 > #++++++++++++++ Tensor tree BSDF generation ++++++++++++++#
174 > sub do_tree_bsdf {
175 > # Get sampling rate and subdivide task
176 > my $ns2 = $ns;
177 > $ns2 /= 2 if ( $tensortree == 3 );
178 > my $nsplice = $nproc;
179 > $nsplice *= 10 if ($nproc > 1);
180 > $nsplice = $ns2 if ($nsplice > $ns2);
181 > $nsplice = 999 if ($nsplice > 999);
182 > @pdiv = (0, int($ns2/$nsplice));
183 > my $nrem = $ns2 % $nsplice;
184 > for (my $i = 1; $i < $nsplice; $i++) {
185 >        my $nv = $pdiv[$i] + $pdiv[1];
186 >        ++$nv if ( $nrem-- > 0 );
187 >        push @pdiv, $nv;
188 > }
189 > die "Script error 1" if ($pdiv[-1] != $ns2);
190 > # Shirley-Chiu mapping from unit square to disk
191 > $sq2disk = '
192 > in_square_a = 2*in_square_x - 1;
193 > in_square_b = 2*in_square_y - 1;
194 > in_square_rgn = if(in_square_a + in_square_b,
195 >                        if(in_square_a - in_square_b, 1, 2),
196 >                        if(in_square_b - in_square_a, 3, 4));
197 > out_disk_r = .999995*select(in_square_rgn, in_square_a, in_square_b,
198 >                        -in_square_a, -in_square_b);
199 > out_disk_phi = PI/4 * select(in_square_rgn,
200 >                                in_square_b/in_square_a,
201 >                                2 - in_square_a/in_square_b,
202 >                                4 + in_square_b/in_square_a,
203 >                                if(in_square_b*in_square_b,
204 >                                        6 - in_square_a/in_square_b, 0));
205 > Dx = out_disk_r*cos(out_disk_phi);
206 > Dy = out_disk_r*sin(out_disk_phi);
207 > Dz = sqrt(1 - out_disk_r*out_disk_r);
208 > ';
209 > # Shirley-Chiu mapping from unit disk to square
210 > $disk2sq = '
211 > norm_radians(p) : if(-p - PI/4, p + 2*PI, p);
212 > in_disk_r = .999995*sqrt(Dx*Dx + Dy*Dy);
213 > in_disk_phi = norm_radians(atan2(Dy, Dx));
214 > in_disk_rgn = floor((in_disk_phi + PI/4)/(PI/2)) + 1;
215 > out_square_a = select(in_disk_rgn,
216 >                        in_disk_r,
217 >                        (PI/2 - in_disk_phi)*in_disk_r/(PI/4),
218 >                        -in_disk_r,
219 >                        (in_disk_phi - 3*PI/2)*in_disk_r/(PI/4));
220 > out_square_b = select(in_disk_rgn,
221 >                        in_disk_phi*in_disk_r/(PI/4),
222 >                        in_disk_r,
223 >                        (PI - in_disk_phi)*in_disk_r/(PI/4),
224 >                        -in_disk_r);
225 > out_square_x = (out_square_a + 1)/2;
226 > out_square_y = (out_square_b + 1)/2;
227 > ';
228 > # Announce ourselves in XML output
229 > print "\t<DataDefinition>\n";
230 > print "\t\t<IncidentDataStructure>TensorTree$tensortree</IncidentDataStructure>\n";
231 > print "\t</DataDefinition>\n";
232 > # Fork parallel rtcontrib processes to compute each side
233 > my $npleft = $nproc;
234 > if ( $doback ) {
235 >        for (my $splice = 0; $splice < $nsplice; $splice++) {
236 >                if (! $npleft ) {
237 >                        wait();
238 >                        die "rtcontrib process reported error" if ( $? );
239 >                        $npleft++;
240 >                }
241 >                bg_tree_rtcontrib(0, $splice);
242 >                $npleft--;
243 >        }
244 >        while (wait() >= 0) {
245 >                die "rtcontrib process reported error" if ( $? );
246 >                $npleft++;
247 >        }
248 >        persist_end();
249 >        ttree_out(0);
250 > }
251 > if ( $doforw ) {
252 >        for (my $splice = 0; $splice < $nsplice; $splice++) {
253 >                if (! $npleft ) {
254 >                        wait();
255 >                        die "rtcontrib process reported error" if ( $? );
256 >                        $npleft++;
257 >                }
258 >                bg_tree_rtcontrib(1, $splice);
259 >                $npleft--;
260 >        }
261 >        while (wait() >= 0) {
262 >                die "rtcontrib process reported error" if ( $? );
263 >                $npleft++;
264 >        }
265 >        persist_end();
266 >        ttree_out(1);
267 > }
268 > }       # end of sub do_tree_bsdf()
269 >
270 > # Run rtcontrib process in background to generate tensor tree samples
271 > sub bg_tree_rtcontrib {
272 >        my $pid = fork();
273 >        die "Cannot fork new process" unless defined $pid;
274 >        if ($pid > 0) { return $pid; }
275 >        my $forw = shift;
276 >        my $pn = shift;
277 >        my $pbeg = $pdiv[$pn];
278 >        my $plen = $pdiv[$pn+1] - $pbeg;
279 >        my $matargs = "-m $bmodnm";
280 >        if ( !$forw || !$doback ) { $matargs .= " -m $fmodnm"; }
281 >        my $cmd = "rtcontrib $rtargs -h -ff -fo -c $nsamp " .
282 >                "-e '$disk2sq' -bn '$ns*$ns' " .
283 >                "-b '$ns*floor(out_square_x*$ns)+floor(out_square_y*$ns)' " .
284 >                "-o $td/%s_" . sprintf("%03d", $pn) . ".flt $matargs $octree";
285 >        if ( $tensortree == 3 ) {
286 >                # Isotropic BSDF
287 >                $cmd = "cnt $plen $ny $nx " .
288 >                        "| rcalc -e 'r1=rand(($pn+.8681)*recno-.673892)' " .
289 >                        "-e 'r2=rand(($pn-5.37138)*recno+67.1737811)' " .
290 >                        "-e 'r3=rand(($pn+3.17603772)*recno+83.766771)' " .
291 >                        "-e 'Dx=1-2*($pbeg+\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)' " .
292 >                        "-e 'xp=(\$3+r2)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
293 >                        "-e 'yp=(\$2+r3)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
294 >                        "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
295 >                        "-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' " .
296 >                        "-e '\$4=Dx;\$5=Dy;\$6=myDz' -of " .
297 >                        "| $cmd";
298 >        } else {
299 >                # Anisotropic BSDF
300 >                # Sample area vertically to improve load balance, since
301 >                # shading systems usually have bilateral symmetry (L-R)
302 >                $cmd = "cnt $plen $ns $ny $nx " .
303 >                        "| rcalc -e 'r1=rand(($pn+.8681)*recno-.673892)' " .
304 >                        "-e 'r2=rand(($pn-5.37138)*recno+67.1737811)' " .
305 >                        "-e 'r3=rand(($pn+3.17603772)*recno+83.766771)' " .
306 >                        "-e 'r4=rand(($pn-2.3857833)*recno-964.72738)' " .
307 >                        "-e 'in_square_x=($pbeg+\$1+r1)/$ns' " .
308 >                        "-e 'in_square_y=(\$2+r2)/$ns' -e '$sq2disk' " .
309 >                        "-e 'xp=(\$4+r3)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
310 >                        "-e 'yp=(\$3+r4)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
311 >                        "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
312 >                        "-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' " .
313 >                        "-e '\$4=Dx;\$5=Dy;\$6=myDz' -of " .
314 >                        "| $cmd";
315 >        }
316 > # print STDERR "Starting: $cmd\n";
317 >        exec($cmd);             # no return; status report to parent via wait
318 >        die "Cannot exec: $cmd\n";
319 > }       # end of bg_tree_rtcontrib()
320 >
321 > # Simplify and output tensor tree results
322 > sub ttree_out {
323 >        my $forw = shift;
324 >        my $side = ("Back","Front")[$forw];
325 >        my $cmd;
326 > # Only output one transmitted distribution, preferring backwards
327 > if ( !$forw || !$doback ) {
328 > print
329 > '       <WavelengthData>
330 >                <LayerNumber>System</LayerNumber>
331 >                <Wavelength unit="Integral">Visible</Wavelength>
332 >                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
333 >                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
334 >                <WavelengthDataBlock>
335 >                        <WavelengthDataDirection>Transmission</WavelengthDataDirection>
336 >                        <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
337 >                        <ScatteringDataType>BTDF</ScatteringDataType>
338 >                        <ScatteringData>
339 > ';
340 > $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
341 >        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' };
342 > if ($pctcull >= 0) {
343 >        $cmd .= "-of $td/" . ($bmodnm,$fmodnm)[$forw] . "_???.flt " .
344 >        "| rttree_reduce -a -h -ff -t $pctcull -r $tensortree -g $ttlog2";
345 >        system "$cmd" || die "Failure running rttree_reduce";
346 > } else {
347 >        $cmd .= "$td/" . ($bmodnm,$fmodnm)[$forw] . "_???.flt";
348 >        print "{\n";
349 >        system "$cmd" || die "Failure running rcalc";
350 >        print "}\n";
351 > }
352 > print
353 > '                       </ScatteringData>
354 >                </WavelengthDataBlock>
355 >        </WavelengthData>
356 > ';
357 > }
358 > # Output reflection
359 > print
360 > '       <WavelengthData>
361 >                <LayerNumber>System</LayerNumber>
362 >                <Wavelength unit="Integral">Visible</Wavelength>
363 >                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
364 >                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
365 >                <WavelengthDataBlock>
366 > ';
367 > print "\t\t\t<WavelengthDataDirection>Reflection $side</WavelengthDataDirection>\n";
368 > print
369 > '                       <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
370 >                        <ScatteringDataType>BRDF</ScatteringDataType>
371 >                        <ScatteringData>
372 > ';
373 > $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
374 >        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' };
375 > if ($pctcull >= 0) {
376 >        $cmd .= "-of $td/" . ($fmodnm,$bmodnm)[$forw] . "_???.flt " .
377 >        "| rttree_reduce -a -h -ff -t $pctcull -r $tensortree -g $ttlog2";
378 >        system "$cmd" || die "Failure running rttree_reduce";
379 > } else {
380 >        $cmd .= "$td/" . ($fmodnm,$bmodnm)[$forw] . "_???.flt";
381 >        print "{\n";
382 >        system "$cmd" || die "Failure running rcalc";
383 >        print "}\n";
384 > }
385 > print
386 > '                       </ScatteringData>
387 >                </WavelengthDataBlock>
388 >        </WavelengthData>
389 > ';
390 > }       # end of ttree_out()
391 >
392 > #------------- End of do_tree_bsdf() & subroutines -------------#
393 >
394 > #+++++++++++++++ Klems matrix BSDF generation +++++++++++++++#
395 > sub do_matrix_bsdf {
396 > # Set up sampling of portal
397   # Kbin to produce incident direction in full Klems basis with (x1,x2) randoms
398 < my $tcal = '
398 > $tcal = '
399   DEGREE : PI/180;
400   sq(x) : x*x;
401   Kpola(r) : select(r+1, -5, 5, 15, 25, 35, 45, 55, 65, 75, 90);
# Line 86 | Line 408 | Kcol = Kbin - Kaccum(Krow-1);
408   Kazi = 360*DEGREE * (Kcol + (.5 - x2)) / Knaz(Krow);
409   Kpol = DEGREE * (x1*Kpola(Krow) + (1-x1)*Kpola(Krow-1));
410   sin_kpol = sin(Kpol);
411 < Dx = -cos(Kazi)*sin_kpol;
411 > Dx = cos(Kazi)*sin_kpol;
412   Dy = sin(Kazi)*sin_kpol;
413   Dz = sqrt(1 - sin_kpol*sin_kpol);
414   KprojOmega = PI * if(Kbin-.5,
415          (sq(cos(Kpola(Krow-1)*DEGREE)) - sq(cos(Kpola(Krow)*DEGREE)))/Knaz(Krow),
416          1 - sq(cos(Kpola(1)*DEGREE)));
417   ';
418 < # Compute Klems bin from exiting ray direction
419 < my $kcal = '
418 > # Compute Klems bin from exiting ray direction (forward or backward)
419 > $kcal = '
420   DEGREE : PI/180;
421 < Acos(x) : 1/DEGREE * if(x-1, 0, if(-1-x, 0, acos(x)));
421 > abs(x) : if(x, x, -x);
422 > Acos(x) : if(x-1, 0, if(-1-x, PI, acos(x))) / DEGREE;
423   posangle(a) : if(-a, a + 2*PI, a);
424 < Atan2(y,x) : 1/DEGREE * posangle(atan2(y,x));
424 > Atan2(y,x) : posangle(atan2(y,x)) / DEGREE;
425   kpola(r) : select(r, 5, 15, 25, 35, 45, 55, 65, 75, 90);
426   knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
427   kaccum(r) : if(r-.5, knaz(r) + kaccum(r-1), 0);
# Line 116 | Line 439 | kbin2(pol,azi) = select(kfindrow(1, pol),
439                  kaccum(7) + kazn(azi,360/knaz(8)),
440                  kaccum(8) + kazn(azi,360/knaz(9))
441          );
442 < kbin = kbin2(Acos(Dz), Atan2(Dy, -Dx));
442 > kbin = kbin2(Acos(abs(Dz)),Atan2(Dy,Dx));
443   ';
444   my $ndiv = 145;
122 my $nx = int(sqrt($nsamp*($dim[1]-$dim[0])/($dim[3]-$dim[2])) + .5);
123 my $ny = int($nsamp/$nx + .5);
124 $nsamp = $nx * $ny;
445   # Compute scattering data using rtcontrib
446 < my $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
446 > my @tfarr;
447 > my @rfarr;
448 > my @tbarr;
449 > my @rbarr;
450 > my $cmd;
451 > my $rtcmd = "rtcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
452 >        "-e '$kcal' -b kbin -bn $ndiv " .
453 >        "-o '$td/%s.flt' -m $fmodnm -m $bmodnm $octree";
454 > my $rccmd = "rcalc -e '$tcal' " .
455 >        "-e 'mod(n,d):n-floor(n/d)*d' -e 'Kbin=mod(recno-.999,$ndiv)' " .
456 >        q{-if3 -e '$1=(0.265*$1+0.670*$2+0.065*$3)/KprojOmega' };
457 > if ( $doforw ) {
458 > $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
459 >        "-e 'xp=(\$3+rand(.12*recno+288))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
460 >        "-e 'yp=(\$2+rand(.37*recno-44))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
461 >        "-e 'zp:$dim[4]' " .
462 >        q{-e 'Kbin=$1;x1=rand(2.75*recno+3.1);x2=rand(-2.01*recno-3.37)' } .
463 >        q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp-Dz;$4=Dx;$5=Dy;$6=Dz' } .
464 >        "| $rtcmd";
465 > system "$cmd" || die "Failure running: $cmd\n";
466 > @tfarr = `$rccmd $td/$fmodnm.flt`;
467 > die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
468 > @rfarr = `$rccmd $td/$bmodnm.flt`;
469 > die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
470 > }
471 > if ( $doback ) {
472 > $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
473          "-e 'xp=(\$3+rand(.35*recno-15))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
474          "-e 'yp=(\$2+rand(.86*recno+11))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
475 <        "-e 'zp:$dim[4]-1e-5' " .
475 >        "-e 'zp:$dim[5]' " .
476          q{-e 'Kbin=$1;x1=rand(1.21*recno+2.75);x2=rand(-3.55*recno-7.57)' } .
477 <        q{-e '$1=xp;$2=yp;$3=zp;$4=Dx;$5=Dy;$6=Dz' } .
478 <        "| rtcontrib -h -ff -n $nproc -c $nsamp -e '$kcal' -b kbin -bn $ndiv " .
479 <        "-m $modnm -w -ab 5 -ad 700 -lw 3e-6 $octree " .
480 <        "| rcalc -e '$tcal' " .
481 <        "-e 'mod(n,d):n-floor(n/d)*d' -e 'Kbin=mod(recno-1,$ndiv)' " .
482 <        q{-if3 -e '$1=(0.265*$1+0.670*$2+0.065*$3)/KprojOmega'};
483 < my @darr = `$cmd`;
484 < die "Failure running: $cmd\n" if ( $? );
485 < # Output XML prologue
140 < print
141 < '<?xml version="1.0" encoding="UTF-8"?>
142 < <WindowElement xmlns="http://windows.lbl.gov" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://windows.lbl.gov/BSDF-v1.4.xsd">
143 <        <WindowElementType>System</WindowElementType>
144 <        <Optical>
145 <                <Layer>
146 <                <Material>
147 <                        <Name>Name</Name>
148 <                        <Manufacturer>Manufacturer</Manufacturer>
149 < ';
150 < printf "\t\t\t<Thickness unit=\"Meter\">%.3f</Thickness>\n", $dim[5] - $dim[4];
151 < printf "\t\t\t<Width unit=\"Meter\">%.3f</Width>\n", $dim[1] - $dim[0];
152 < printf "\t\t\t<Height unit=\"Meter\">%.3f</Height>\n", $dim[3] - $dim[2];
153 < print "\t\t\t<DeviceType>Integral</DeviceType>\n";
154 < # Output MGF description if requested
155 < if ( $geout ) {
156 <        print "\t\t\t<Geometry format=\"MGF\" unit=\"Meter\">\n";
157 <        printf "xf -t %.6f %.6f 0\n", -($dim[0]+$dim[1])/2, -($dim[2]+$dim[3])/2;
158 <        system "cat $mgfscn";
159 <        print "xf\n";
160 <        print "\t\t\t</Geometry>\n";
477 >        q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp+Dz;$4=Dx;$5=Dy;$6=-Dz' } .
478 >        "| $rtcmd";
479 > system "$cmd" || die "Failure running: $cmd\n";
480 > @tbarr = `$rccmd $td/$bmodnm.flt`;
481 > die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
482 > chomp(@tbarr);
483 > @rbarr = `$rccmd $td/$fmodnm.flt`;
484 > die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
485 > chomp(@rbarr);
486   }
487 < print '                 </Material>
488 <                <DataDefinition>
489 <                        <IncidentDataStructure>Columns</IncidentDataStructure>
490 <                        <AngleBasis>
487 > # Output angle basis
488 > print
489 > '       <DataDefinition>
490 >                <IncidentDataStructure>Columns</IncidentDataStructure>
491 >                <AngleBasis>
492                          <AngleBasisName>LBNL/Klems Full</AngleBasisName>
493 <                                <AngleBasisBlock>
493 >                        <AngleBasisBlock>
494                                  <Theta>0</Theta>
495                                  <nPhis>1</nPhis>
496                                  <ThetaBounds>
497 <                                <LowerTheta>0</LowerTheta>
498 <                                <UpperTheta>5</UpperTheta>
497 >                                        <LowerTheta>0</LowerTheta>
498 >                                        <UpperTheta>5</UpperTheta>
499                                  </ThetaBounds>
500                                  </AngleBasisBlock>
501                                  <AngleBasisBlock>
# Line 238 | Line 564 | print '                        </Material>
564                          </AngleBasisBlock>
565                  </AngleBasis>
566          </DataDefinition>
567 <        <WavelengthData>
567 > ';
568 > if ( $doforw ) {
569 > print
570 > '       <WavelengthData>
571                  <LayerNumber>System</LayerNumber>
572                  <Wavelength unit="Integral">Visible</Wavelength>
573                  <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
# Line 250 | Line 579 | print '                        </Material>
579                          <ScatteringDataType>BTDF</ScatteringDataType>
580                          <ScatteringData>
581   ';
582 < # Output computed data (transposed order)
582 > # Output front transmission (transposed order)
583   for (my $od = 0; $od < $ndiv; $od++) {
584          for (my $id = 0; $id < $ndiv; $id++) {
585 <                print $darr[$ndiv*$id + $od];
585 >                print $tfarr[$ndiv*$id + $od], ",\n";
586          }
587          print "\n";
588   }
260 # Output XML epilogue
589   print
590 < '               </ScatteringData>
591 <        </WavelengthDataBlock>
590 > '                       </ScatteringData>
591 >                </WavelengthDataBlock>
592          </WavelengthData>
593 < </Layer>
594 < </Optical>
595 < </WindowElement>
593 >        <WavelengthData>
594 >                <LayerNumber>System</LayerNumber>
595 >                <Wavelength unit="Integral">Visible</Wavelength>
596 >                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
597 >                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
598 >                <WavelengthDataBlock>
599 >                        <WavelengthDataDirection>Reflection Front</WavelengthDataDirection>
600 >                        <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
601 >                        <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
602 >                        <ScatteringDataType>BRDF</ScatteringDataType>
603 >                        <ScatteringData>
604   ';
605 < # Clean up temporary files
606 < system "rm -rf $td";
605 > # Output front reflection (transposed order)
606 > for (my $od = 0; $od < $ndiv; $od++) {
607 >        for (my $id = 0; $id < $ndiv; $id++) {
608 >                print $rfarr[$ndiv*$id + $od], ",\n";
609 >        }
610 >        print "\n";
611 > }
612 > print
613 > '                       </ScatteringData>
614 >                </WavelengthDataBlock>
615 >        </WavelengthData>
616 > ';
617 > }
618 > if ( $doback ) {
619 > print
620 > '       <WavelengthData>
621 >                <LayerNumber>System</LayerNumber>
622 >                <Wavelength unit="Integral">Visible</Wavelength>
623 >                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
624 >                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
625 >                <WavelengthDataBlock>
626 >                        <WavelengthDataDirection>Transmission Back</WavelengthDataDirection>
627 >                        <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
628 >                        <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
629 >                        <ScatteringDataType>BTDF</ScatteringDataType>
630 >                        <ScatteringData>
631 > ';
632 > # Output back transmission (transposed order)
633 > for (my $od = 0; $od < $ndiv; $od++) {
634 >        for (my $id = 0; $id < $ndiv; $id++) {
635 >                print $tbarr[$ndiv*$id + $od], ",\n";
636 >        }
637 >        print "\n";
638 > }
639 > print
640 > '                       </ScatteringData>
641 >                </WavelengthDataBlock>
642 >        </WavelengthData>
643 >        <WavelengthData>
644 >                <LayerNumber>System</LayerNumber>
645 >                <Wavelength unit="Integral">Visible</Wavelength>
646 >                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
647 >                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
648 >                <WavelengthDataBlock>
649 >                        <WavelengthDataDirection>Reflection Back</WavelengthDataDirection>
650 >                        <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
651 >                        <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
652 >                        <ScatteringDataType>BRDF</ScatteringDataType>
653 >                        <ScatteringData>
654 > ';
655 > # Output back reflection (transposed order)
656 > for (my $od = 0; $od < $ndiv; $od++) {
657 >        for (my $id = 0; $id < $ndiv; $id++) {
658 >                print $rbarr[$ndiv*$id + $od], ",\n";
659 >        }
660 >        print "\n";
661 > }
662 > print
663 > '                       </ScatteringData>
664 >                </WavelengthDataBlock>
665 >        </WavelengthData>
666 > ';
667 > }
668 > }
669 > #------------- End of do_matrix_bsdf() --------------#

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines